diff --git a/backend/src/graphql/resolver/AdminResolver.ts b/backend/src/graphql/resolver/AdminResolver.ts
index 4c94e48c8..84ae09cf8 100644
--- a/backend/src/graphql/resolver/AdminResolver.ts
+++ b/backend/src/graphql/resolver/AdminResolver.ts
@@ -1,4 +1,5 @@
 import { Context, getUser } from '@/server/context'
+import { backendLogger as logger } from '@/server/logger'
 import { Resolver, Query, Arg, Args, Authorized, Mutation, Ctx, Int } from 'type-graphql'
 import {
   getCustomRepository,
@@ -11,21 +12,25 @@ import {
   FindOperator,
 } from '@dbTools/typeorm'
 import { UserAdmin, SearchUsersResult } from '@model/UserAdmin'
-import { PendingCreation } from '@model/PendingCreation'
-import { CreatePendingCreations } from '@model/CreatePendingCreations'
-import { UpdatePendingCreation } from '@model/UpdatePendingCreation'
+import { UnconfirmedContribution } from '@model/UnconfirmedContribution'
+import { AdminCreateContributions } from '@model/AdminCreateContributions'
+import { AdminUpdateContribution } from '@model/AdminUpdateContribution'
+import { ContributionLink } from '@model/ContributionLink'
+import { ContributionLinkList } from '@model/ContributionLinkList'
 import { RIGHTS } from '@/auth/RIGHTS'
 import { UserRepository } from '@repository/User'
-import CreatePendingCreationArgs from '@arg/CreatePendingCreationArgs'
-import UpdatePendingCreationArgs from '@arg/UpdatePendingCreationArgs'
+import AdminCreateContributionArgs from '@arg/AdminCreateContributionArgs'
+import AdminUpdateContributionArgs from '@arg/AdminUpdateContributionArgs'
 import SearchUsersArgs from '@arg/SearchUsersArgs'
+import ContributionLinkArgs from '@arg/ContributionLinkArgs'
 import { Transaction as DbTransaction } from '@entity/Transaction'
+import { ContributionLink as DbContributionLink } from '@entity/ContributionLink'
 import { Transaction } from '@model/Transaction'
 import { TransactionLink, TransactionLinkResult } from '@model/TransactionLink'
 import { TransactionLink as dbTransactionLink } from '@entity/TransactionLink'
 import { TransactionRepository } from '@repository/Transaction'
 import { calculateDecay } from '@/util/decay'
-import { AdminPendingCreation } from '@entity/AdminPendingCreation'
+import { Contribution } from '@entity/Contribution'
 import { hasElopageBuys } from '@/util/hasElopageBuys'
 import { LoginEmailOptIn } from '@entity/LoginEmailOptIn'
 import { User as dbUser } from '@entity/User'
@@ -39,12 +44,25 @@ import { Order } from '@enum/Order'
 import { communityUser } from '@/util/communityUser'
 import { checkOptInCode, activationLink, printTimeDuration } from './UserResolver'
 import { sendAccountActivationEmail } from '@/mailer/sendAccountActivationEmail'
+import { transactionLinkCode as contributionLinkCode } from './TransactionLinkResolver'
 import CONFIG from '@/config'
+import {
+  getUserCreation,
+  getUserCreations,
+  validateContribution,
+  isStartEndDateValid,
+  updateCreations,
+} from './util/creations'
+import {
+  CONTRIBUTIONLINK_NAME_MAX_CHARS,
+  CONTRIBUTIONLINK_NAME_MIN_CHARS,
+  FULL_CREATION_AVAILABLE,
+  MEMO_MAX_CHARS,
+  MEMO_MIN_CHARS,
+} from './const/const'
 
 // const EMAIL_OPT_IN_REGISTER = 1
 // const EMAIL_OPT_UNKNOWN = 3 // elopage?
-const MAX_CREATION_AMOUNT = new Decimal(1000)
-const FULL_CREATION_AVAILABLE = [MAX_CREATION_AMOUNT, MAX_CREATION_AMOUNT, MAX_CREATION_AMOUNT]
 
 @Resolver()
 export class AdminResolver {
@@ -67,7 +85,15 @@ export class AdminResolver {
       }
     }
 
-    const userFields = ['id', 'firstName', 'lastName', 'email', 'emailChecked', 'deletedAt']
+    const userFields = [
+      'id',
+      'firstName',
+      'lastName',
+      'email',
+      'emailChecked',
+      'deletedAt',
+      'isAdmin',
+    ]
     const [users, count] = await userRepository.findBySearchCriteriaPagedFiltered(
       userFields.map((fieldName) => {
         return 'user.' + fieldName
@@ -127,6 +153,48 @@ export class AdminResolver {
     }
   }
 
+  @Authorized([RIGHTS.SET_USER_ROLE])
+  @Mutation(() => Date, { nullable: true })
+  async setUserRole(
+    @Arg('userId', () => Int)
+    userId: number,
+    @Arg('isAdmin', () => Boolean)
+    isAdmin: boolean,
+    @Ctx()
+    context: Context,
+  ): Promise<Date | null> {
+    const user = await dbUser.findOne({ id: userId })
+    // user exists ?
+    if (!user) {
+      throw new Error(`Could not find user with userId: ${userId}`)
+    }
+    // administrator user changes own role?
+    const moderatorUser = getUser(context)
+    if (moderatorUser.id === userId) {
+      throw new Error('Administrator can not change his own role!')
+    }
+    // change isAdmin
+    switch (user.isAdmin) {
+      case null:
+        if (isAdmin === true) {
+          user.isAdmin = new Date()
+        } else {
+          throw new Error('User is already a usual user!')
+        }
+        break
+      default:
+        if (isAdmin === false) {
+          user.isAdmin = null
+        } else {
+          throw new Error('User is already admin!')
+        }
+        break
+    }
+    await user.save()
+    const newUser = await dbUser.findOne({ id: userId })
+    return newUser ? newUser.isAdmin : null
+  }
+
   @Authorized([RIGHTS.DELETE_USER])
   @Mutation(() => Date, { nullable: true })
   async deleteUser(
@@ -163,10 +231,10 @@ export class AdminResolver {
     return null
   }
 
-  @Authorized([RIGHTS.CREATE_PENDING_CREATION])
+  @Authorized([RIGHTS.ADMIN_CREATE_CONTRIBUTION])
   @Mutation(() => [Number])
-  async createPendingCreation(
-    @Args() { email, amount, memo, creationDate }: CreatePendingCreationArgs,
+  async adminCreateContribution(
+    @Args() { email, amount, memo, creationDate }: AdminCreateContributionArgs,
     @Ctx() context: Context,
   ): Promise<Decimal[]> {
     const user = await dbUser.findOne({ email }, { withDeleted: true })
@@ -174,61 +242,63 @@ export class AdminResolver {
       throw new Error(`Could not find user with email: ${email}`)
     }
     if (user.deletedAt) {
-      throw new Error('This user was deleted. Cannot make a creation.')
+      throw new Error('This user was deleted. Cannot create a contribution.')
     }
     if (!user.emailChecked) {
-      throw new Error('Creation could not be saved, Email is not activated')
+      throw new Error('Contribution could not be saved, Email is not activated')
     }
     const moderator = getUser(context)
+    logger.trace('moderator: ', moderator.id)
     const creations = await getUserCreation(user.id)
+    logger.trace('creations', creations)
     const creationDateObj = new Date(creationDate)
-    if (isCreationValid(creations, amount, creationDateObj)) {
-      const adminPendingCreation = AdminPendingCreation.create()
-      adminPendingCreation.userId = user.id
-      adminPendingCreation.amount = amount
-      adminPendingCreation.created = new Date()
-      adminPendingCreation.date = creationDateObj
-      adminPendingCreation.memo = memo
-      adminPendingCreation.moderator = moderator.id
+    validateContribution(creations, amount, creationDateObj)
+    const contribution = Contribution.create()
+    contribution.userId = user.id
+    contribution.amount = amount
+    contribution.createdAt = new Date()
+    contribution.contributionDate = creationDateObj
+    contribution.memo = memo
+    contribution.moderatorId = moderator.id
 
-      await AdminPendingCreation.save(adminPendingCreation)
-    }
+    logger.trace('contribution to save', contribution)
+    await Contribution.save(contribution)
     return getUserCreation(user.id)
   }
 
-  @Authorized([RIGHTS.CREATE_PENDING_CREATION])
-  @Mutation(() => CreatePendingCreations)
-  async createPendingCreations(
-    @Arg('pendingCreations', () => [CreatePendingCreationArgs])
-    pendingCreations: CreatePendingCreationArgs[],
+  @Authorized([RIGHTS.ADMIN_CREATE_CONTRIBUTIONS])
+  @Mutation(() => AdminCreateContributions)
+  async adminCreateContributions(
+    @Arg('pendingCreations', () => [AdminCreateContributionArgs])
+    contributions: AdminCreateContributionArgs[],
     @Ctx() context: Context,
-  ): Promise<CreatePendingCreations> {
+  ): Promise<AdminCreateContributions> {
     let success = false
-    const successfulCreation: string[] = []
-    const failedCreation: string[] = []
-    for (const pendingCreation of pendingCreations) {
-      await this.createPendingCreation(pendingCreation, context)
+    const successfulContribution: string[] = []
+    const failedContribution: string[] = []
+    for (const contribution of contributions) {
+      await this.adminCreateContribution(contribution, context)
         .then(() => {
-          successfulCreation.push(pendingCreation.email)
+          successfulContribution.push(contribution.email)
           success = true
         })
         .catch(() => {
-          failedCreation.push(pendingCreation.email)
+          failedContribution.push(contribution.email)
         })
     }
     return {
       success,
-      successfulCreation,
-      failedCreation,
+      successfulContribution,
+      failedContribution,
     }
   }
 
-  @Authorized([RIGHTS.UPDATE_PENDING_CREATION])
-  @Mutation(() => UpdatePendingCreation)
-  async updatePendingCreation(
-    @Args() { id, email, amount, memo, creationDate }: UpdatePendingCreationArgs,
+  @Authorized([RIGHTS.ADMIN_UPDATE_CONTRIBUTION])
+  @Mutation(() => AdminUpdateContribution)
+  async adminUpdateContribution(
+    @Args() { id, email, amount, memo, creationDate }: AdminUpdateContributionArgs,
     @Ctx() context: Context,
-  ): Promise<UpdatePendingCreation> {
+  ): Promise<AdminUpdateContribution> {
     const user = await dbUser.findOne({ email }, { withDeleted: true })
     if (!user) {
       throw new Error(`Could not find user with email: ${email}`)
@@ -239,59 +309,69 @@ export class AdminResolver {
 
     const moderator = getUser(context)
 
-    const pendingCreationToUpdate = await AdminPendingCreation.findOne({ id })
+    const contributionToUpdate = await Contribution.findOne({
+      where: { id, confirmedAt: IsNull() },
+    })
 
-    if (!pendingCreationToUpdate) {
-      throw new Error('No creation found to given id.')
+    if (!contributionToUpdate) {
+      throw new Error('No contribution found to given id.')
     }
 
-    if (pendingCreationToUpdate.userId !== user.id) {
-      throw new Error('user of the pending creation and send user does not correspond')
+    if (contributionToUpdate.userId !== user.id) {
+      throw new Error('user of the pending contribution and send user does not correspond')
+    }
+
+    if (contributionToUpdate.moderatorId === null) {
+      throw new Error('An admin is not allowed to update a user contribution.')
     }
 
     const creationDateObj = new Date(creationDate)
     let creations = await getUserCreation(user.id)
-    if (pendingCreationToUpdate.date.getMonth() === creationDateObj.getMonth()) {
-      creations = updateCreations(creations, pendingCreationToUpdate)
+    if (contributionToUpdate.contributionDate.getMonth() === creationDateObj.getMonth()) {
+      creations = updateCreations(creations, contributionToUpdate)
     }
 
     // all possible cases not to be true are thrown in this function
-    isCreationValid(creations, amount, creationDateObj)
-    pendingCreationToUpdate.amount = amount
-    pendingCreationToUpdate.memo = memo
-    pendingCreationToUpdate.date = new Date(creationDate)
-    pendingCreationToUpdate.moderator = moderator.id
+    validateContribution(creations, amount, creationDateObj)
+    contributionToUpdate.amount = amount
+    contributionToUpdate.memo = memo
+    contributionToUpdate.contributionDate = new Date(creationDate)
+    contributionToUpdate.moderatorId = moderator.id
 
-    await AdminPendingCreation.save(pendingCreationToUpdate)
-    const result = new UpdatePendingCreation()
+    await Contribution.save(contributionToUpdate)
+    const result = new AdminUpdateContribution()
     result.amount = amount
-    result.memo = pendingCreationToUpdate.memo
-    result.date = pendingCreationToUpdate.date
+    result.memo = contributionToUpdate.memo
+    result.date = contributionToUpdate.contributionDate
 
     result.creation = await getUserCreation(user.id)
 
     return result
   }
 
-  @Authorized([RIGHTS.SEARCH_PENDING_CREATION])
-  @Query(() => [PendingCreation])
-  async getPendingCreations(): Promise<PendingCreation[]> {
-    const pendingCreations = await AdminPendingCreation.find()
-    if (pendingCreations.length === 0) {
+  @Authorized([RIGHTS.LIST_UNCONFIRMED_CONTRIBUTIONS])
+  @Query(() => [UnconfirmedContribution])
+  async listUnconfirmedContributions(): Promise<UnconfirmedContribution[]> {
+    const contributions = await Contribution.find({ where: { confirmedAt: IsNull() } })
+    if (contributions.length === 0) {
       return []
     }
 
-    const userIds = pendingCreations.map((p) => p.userId)
+    const userIds = contributions.map((p) => p.userId)
     const userCreations = await getUserCreations(userIds)
     const users = await dbUser.find({ where: { id: In(userIds) }, withDeleted: true })
 
-    return pendingCreations.map((pendingCreation) => {
-      const user = users.find((u) => u.id === pendingCreation.userId)
-      const creation = userCreations.find((c) => c.id === pendingCreation.userId)
+    return contributions.map((contribution) => {
+      const user = users.find((u) => u.id === contribution.userId)
+      const creation = userCreations.find((c) => c.id === contribution.userId)
 
       return {
-        ...pendingCreation,
-        amount: pendingCreation.amount,
+        id: contribution.id,
+        userId: contribution.userId,
+        date: contribution.contributionDate,
+        memo: contribution.memo,
+        amount: contribution.amount,
+        moderator: contribution.moderatorId,
         firstName: user ? user.firstName : '',
         lastName: user ? user.lastName : '',
         email: user ? user.email : '',
@@ -300,69 +380,91 @@ export class AdminResolver {
     })
   }
 
-  @Authorized([RIGHTS.DELETE_PENDING_CREATION])
+  @Authorized([RIGHTS.ADMIN_DELETE_CONTRIBUTION])
   @Mutation(() => Boolean)
-  async deletePendingCreation(@Arg('id', () => Int) id: number): Promise<boolean> {
-    const pendingCreation = await AdminPendingCreation.findOne(id)
-    if (!pendingCreation) {
-      throw new Error('Creation not found for given id.')
+  async adminDeleteContribution(@Arg('id', () => Int) id: number): Promise<boolean> {
+    const contribution = await Contribution.findOne(id)
+    if (!contribution) {
+      throw new Error('Contribution not found for given id.')
     }
-    const res = await AdminPendingCreation.delete(pendingCreation)
+    const res = await contribution.softRemove()
     return !!res
   }
 
-  @Authorized([RIGHTS.CONFIRM_PENDING_CREATION])
+  @Authorized([RIGHTS.CONFIRM_CONTRIBUTION])
   @Mutation(() => Boolean)
-  async confirmPendingCreation(
+  async confirmContribution(
     @Arg('id', () => Int) id: number,
     @Ctx() context: Context,
   ): Promise<boolean> {
-    const pendingCreation = await AdminPendingCreation.findOne(id)
-    if (!pendingCreation) {
-      throw new Error('Creation not found to given id.')
+    const contribution = await Contribution.findOne(id)
+    if (!contribution) {
+      throw new Error('Contribution not found to given id.')
     }
     const moderatorUser = getUser(context)
-    if (moderatorUser.id === pendingCreation.userId)
-      throw new Error('Moderator can not confirm own pending creation')
+    if (moderatorUser.id === contribution.userId)
+      throw new Error('Moderator can not confirm own contribution')
 
-    const user = await dbUser.findOneOrFail({ id: pendingCreation.userId }, { withDeleted: true })
-    if (user.deletedAt) throw new Error('This user was deleted. Cannot confirm a creation.')
+    const user = await dbUser.findOneOrFail({ id: contribution.userId }, { withDeleted: true })
+    if (user.deletedAt) throw new Error('This user was deleted. Cannot confirm a contribution.')
 
-    const creations = await getUserCreation(pendingCreation.userId, false)
-    if (!isCreationValid(creations, pendingCreation.amount, pendingCreation.date)) {
-      throw new Error('Creation is not valid!!')
-    }
+    const creations = await getUserCreation(contribution.userId, false)
+    validateContribution(creations, contribution.amount, contribution.contributionDate)
 
     const receivedCallDate = new Date()
 
-    const transactionRepository = getCustomRepository(TransactionRepository)
-    const lastTransaction = await transactionRepository.findLastForUser(pendingCreation.userId)
+    const queryRunner = getConnection().createQueryRunner()
+    await queryRunner.connect()
+    await queryRunner.startTransaction('READ UNCOMMITTED')
+    try {
+      const lastTransaction = await queryRunner.manager
+        .createQueryBuilder()
+        .select('transaction')
+        .from(DbTransaction, 'transaction')
+        .where('transaction.userId = :id', { id: contribution.userId })
+        .orderBy('transaction.balanceDate', 'DESC')
+        .getOne()
+      logger.info('lastTransaction ID', lastTransaction ? lastTransaction.id : 'undefined')
 
-    let newBalance = new Decimal(0)
-    let decay: Decay | null = null
-    if (lastTransaction) {
-      decay = calculateDecay(lastTransaction.balance, lastTransaction.balanceDate, receivedCallDate)
-      newBalance = decay.balance
+      let newBalance = new Decimal(0)
+      let decay: Decay | null = null
+      if (lastTransaction) {
+        decay = calculateDecay(
+          lastTransaction.balance,
+          lastTransaction.balanceDate,
+          receivedCallDate,
+        )
+        newBalance = decay.balance
+      }
+      newBalance = newBalance.add(contribution.amount.toString())
+
+      const transaction = new DbTransaction()
+      transaction.typeId = TransactionTypeId.CREATION
+      transaction.memo = contribution.memo
+      transaction.userId = contribution.userId
+      transaction.previous = lastTransaction ? lastTransaction.id : null
+      transaction.amount = contribution.amount
+      transaction.creationDate = contribution.contributionDate
+      transaction.balance = newBalance
+      transaction.balanceDate = receivedCallDate
+      transaction.decay = decay ? decay.decay : new Decimal(0)
+      transaction.decayStart = decay ? decay.start : null
+      await queryRunner.manager.insert(DbTransaction, transaction)
+
+      contribution.confirmedAt = receivedCallDate
+      contribution.confirmedBy = moderatorUser.id
+      contribution.transactionId = transaction.id
+      await queryRunner.manager.update(Contribution, { id: contribution.id }, contribution)
+
+      await queryRunner.commitTransaction()
+      logger.info('creation commited successfuly.')
+    } catch (e) {
+      await queryRunner.rollbackTransaction()
+      logger.error(`Creation was not successful: ${e}`)
+      throw new Error(`Creation was not successful.`)
+    } finally {
+      await queryRunner.release()
     }
-    newBalance = newBalance.add(pendingCreation.amount.toString())
-
-    const transaction = new DbTransaction()
-    transaction.typeId = TransactionTypeId.CREATION
-    transaction.memo = pendingCreation.memo
-    transaction.userId = pendingCreation.userId
-    transaction.previous = lastTransaction ? lastTransaction.id : null
-    transaction.amount = pendingCreation.amount
-    transaction.creationDate = pendingCreation.date
-    transaction.balance = newBalance
-    transaction.balanceDate = receivedCallDate
-    transaction.decay = decay ? decay.decay : new Decimal(0)
-    transaction.decayStart = decay ? decay.start : null
-    await transaction.save().catch(() => {
-      throw new Error('Unable to confirm creation.')
-    })
-
-    await AdminPendingCreation.delete(pendingCreation)
-
     return true
   }
 
@@ -460,96 +562,130 @@ export class AdminResolver {
       linkList: transactionLinks.map((tl) => new TransactionLink(tl, new User(user))),
     }
   }
-}
 
-interface CreationMap {
-  id: number
-  creations: Decimal[]
-}
-
-async function getUserCreation(id: number, includePending = true): Promise<Decimal[]> {
-  const creations = await getUserCreations([id], includePending)
-  return creations[0] ? creations[0].creations : FULL_CREATION_AVAILABLE
-}
-
-async function getUserCreations(ids: number[], includePending = true): Promise<CreationMap[]> {
-  const months = getCreationMonths()
-
-  const queryRunner = getConnection().createQueryRunner()
-  await queryRunner.connect()
-
-  const dateFilter = 'last_day(curdate() - interval 3 month) + interval 1 day'
-
-  const unionString = includePending
-    ? `
-    UNION
-      SELECT date AS date, amount AS amount, userId AS userId FROM admin_pending_creations
-        WHERE userId IN (${ids.toString()})
-        AND date >= ${dateFilter}`
-    : ''
-
-  const unionQuery = await queryRunner.manager.query(`
-    SELECT MONTH(date) AS month, sum(amount) AS sum, userId AS id FROM
-      (SELECT creation_date AS date, amount AS amount, user_id AS userId FROM transactions
-        WHERE user_id IN (${ids.toString()})
-        AND type_id = ${TransactionTypeId.CREATION}
-        AND creation_date >= ${dateFilter}
-      ${unionString}) AS result
-    GROUP BY month, userId
-    ORDER BY date DESC
-  `)
-
-  await queryRunner.release()
-
-  return ids.map((id) => {
-    return {
-      id,
-      creations: months.map((month) => {
-        const creation = unionQuery.find(
-          (raw: { month: string; id: string; creation: number[] }) =>
-            parseInt(raw.month) === month && parseInt(raw.id) === id,
-        )
-        return MAX_CREATION_AMOUNT.minus(creation ? creation.sum : 0)
-      }),
+  @Authorized([RIGHTS.CREATE_CONTRIBUTION_LINK])
+  @Mutation(() => ContributionLink)
+  async createContributionLink(
+    @Args()
+    {
+      amount,
+      name,
+      memo,
+      cycle,
+      validFrom,
+      validTo,
+      maxAmountPerMonth,
+      maxPerCycle,
+    }: ContributionLinkArgs,
+  ): Promise<ContributionLink> {
+    isStartEndDateValid(validFrom, validTo)
+    if (!name) {
+      logger.error(`The name must be initialized!`)
+      throw new Error(`The name must be initialized!`)
     }
-  })
-}
-
-function updateCreations(creations: Decimal[], pendingCreation: AdminPendingCreation): Decimal[] {
-  const index = getCreationIndex(pendingCreation.date.getMonth())
-
-  if (index < 0) {
-    throw new Error('You cannot create GDD for a month older than the last three months.')
-  }
-  creations[index] = creations[index].plus(pendingCreation.amount.toString())
-  return creations
-}
-
-function isCreationValid(creations: Decimal[], amount: Decimal, creationDate: Date) {
-  const index = getCreationIndex(creationDate.getMonth())
-
-  if (index < 0) {
-    throw new Error('No information for available creations for the given date')
+    if (
+      name.length < CONTRIBUTIONLINK_NAME_MIN_CHARS ||
+      name.length > CONTRIBUTIONLINK_NAME_MAX_CHARS
+    ) {
+      const msg = `The value of 'name' with a length of ${name.length} did not fulfill the requested bounderies min=${CONTRIBUTIONLINK_NAME_MIN_CHARS} and max=${CONTRIBUTIONLINK_NAME_MAX_CHARS}`
+      logger.error(`${msg}`)
+      throw new Error(`${msg}`)
+    }
+    if (!memo) {
+      logger.error(`The memo must be initialized!`)
+      throw new Error(`The memo must be initialized!`)
+    }
+    if (memo.length < MEMO_MIN_CHARS || memo.length > MEMO_MAX_CHARS) {
+      const msg = `The value of 'memo' with a length of ${memo.length} did not fulfill the requested bounderies min=${MEMO_MIN_CHARS} and max=${MEMO_MAX_CHARS}`
+      logger.error(`${msg}`)
+      throw new Error(`${msg}`)
+    }
+    if (!amount) {
+      logger.error(`The amount must be initialized!`)
+      throw new Error('The amount must be initialized!')
+    }
+    if (!new Decimal(amount).isPositive()) {
+      logger.error(`The amount=${amount} must be initialized with a positiv value!`)
+      throw new Error(`The amount=${amount} must be initialized with a positiv value!`)
+    }
+    const dbContributionLink = new DbContributionLink()
+    dbContributionLink.amount = amount
+    dbContributionLink.name = name
+    dbContributionLink.memo = memo
+    dbContributionLink.createdAt = new Date()
+    dbContributionLink.code = contributionLinkCode(dbContributionLink.createdAt)
+    dbContributionLink.cycle = cycle
+    if (validFrom) dbContributionLink.validFrom = new Date(validFrom)
+    if (validTo) dbContributionLink.validTo = new Date(validTo)
+    dbContributionLink.maxAmountPerMonth = maxAmountPerMonth
+    dbContributionLink.maxPerCycle = maxPerCycle
+    await dbContributionLink.save()
+    logger.debug(`createContributionLink successful!`)
+    return new ContributionLink(dbContributionLink)
   }
 
-  if (amount.greaterThan(creations[index].toString())) {
-    throw new Error(
-      `The amount (${amount} GDD) to be created exceeds the amount (${creations[index]} GDD) still available for this month.`,
-    )
+  @Authorized([RIGHTS.LIST_CONTRIBUTION_LINKS])
+  @Query(() => ContributionLinkList)
+  async listContributionLinks(
+    @Args()
+    { currentPage = 1, pageSize = 5, order = Order.DESC }: Paginated,
+  ): Promise<ContributionLinkList> {
+    const [links, count] = await DbContributionLink.findAndCount({
+      order: { createdAt: order },
+      skip: (currentPage - 1) * pageSize,
+      take: pageSize,
+    })
+    return {
+      links: links.map((link: DbContributionLink) => new ContributionLink(link)),
+      count,
+    }
   }
 
-  return true
-}
+  @Authorized([RIGHTS.DELETE_CONTRIBUTION_LINK])
+  @Mutation(() => Date, { nullable: true })
+  async deleteContributionLink(@Arg('id', () => Int) id: number): Promise<Date | null> {
+    const contributionLink = await DbContributionLink.findOne(id)
+    if (!contributionLink) {
+      logger.error(`Contribution Link not found to given id: ${id}`)
+      throw new Error('Contribution Link not found to given id.')
+    }
+    await contributionLink.softRemove()
+    logger.debug(`deleteContributionLink successful!`)
+    const newContributionLink = await DbContributionLink.findOne({ id }, { withDeleted: true })
+    return newContributionLink ? newContributionLink.deletedAt : null
+  }
 
-const getCreationMonths = (): number[] => {
-  const now = new Date(Date.now())
-  return [
-    now.getMonth() + 1,
-    new Date(now.getFullYear(), now.getMonth() - 1, 1).getMonth() + 1,
-    new Date(now.getFullYear(), now.getMonth() - 2, 1).getMonth() + 1,
-  ].reverse()
-}
-
-const getCreationIndex = (month: number): number => {
-  return getCreationMonths().findIndex((el) => el === month + 1)
+  @Authorized([RIGHTS.UPDATE_CONTRIBUTION_LINK])
+  @Mutation(() => ContributionLink)
+  async updateContributionLink(
+    @Args()
+    {
+      amount,
+      name,
+      memo,
+      cycle,
+      validFrom,
+      validTo,
+      maxAmountPerMonth,
+      maxPerCycle,
+    }: ContributionLinkArgs,
+    @Arg('id', () => Int) id: number,
+  ): Promise<ContributionLink> {
+    const dbContributionLink = await DbContributionLink.findOne(id)
+    if (!dbContributionLink) {
+      logger.error(`Contribution Link not found to given id: ${id}`)
+      throw new Error('Contribution Link not found to given id.')
+    }
+    dbContributionLink.amount = amount
+    dbContributionLink.name = name
+    dbContributionLink.memo = memo
+    dbContributionLink.cycle = cycle
+    if (validFrom) dbContributionLink.validFrom = new Date(validFrom)
+    if (validTo) dbContributionLink.validTo = new Date(validTo)
+    dbContributionLink.maxAmountPerMonth = maxAmountPerMonth
+    dbContributionLink.maxPerCycle = maxPerCycle
+    await dbContributionLink.save()
+    logger.debug(`updateContributionLink successful!`)
+    return new ContributionLink(dbContributionLink)
+  }
 }
